/* System specific resource deallocation.  Generic version.
   Copyright (C) 2022-2025 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <https://www.gnu.org/licenses/>.  */

/* Each system may define weak functions to free any resource allocated with
   malloc to avoid interfere with mtrace.  */

#include <set-freeres-os.h>
#include <set-freeres-fp.h>

#define call_freeres_system_funcs	\
  call_freeres_os_funcs;		\
  call_freeres_fp_funcs
